# Wick&d

Wick&d is a python library that implements the algebra of second quantization for fermionic systems.
Wick&d implements Wick's contraction theorem for general Fermi vacua.

<img src="https://github.com/fevangelista/wickd/raw/main/lib/logo.png" width="300">

[![Pip](https://github.com/fevangelista/wickd/actions/workflows/pip.yml/badge.svg)](https://github.com/fevangelista/wickd/actions/workflows/pip.yml)
[![Wheels](https://github.com/fevangelista/wickd/actions/workflows/wheels.yml/badge.svg)](https://github.com/fevangelista/wickd/actions/workflows/wheels.yml)
[![codecov](https://codecov.io/gh/fevangelista/wickd/branch/main/graph/badge.svg?token=oe5ECK9O1N)](https://codecov.io/gh/fevangelista/wickd)
[![DOI](https://zenodo.org/badge/64144811.svg)](https://zenodo.org/badge/latestdoi/64144811)

## Installation (develpment version)

To install Wick&d, clone this repository (including its submodule pybind11) and compile it using the `pip install` command:

```bash
git clone --recurse-submodules https://github.com/fevangelista/wickd.git
cd wickd
pip install --no-build-isolation -ve .
```

## Getting started

To learn how to use Wick&d start from the [jupyter tutorials](https://github.com/fevangelista/wickd/tree/main/tutorials).
There are also a few examples of ways to use Wick&d in the [examples directory](https://github.com/fevangelista/wickd/tree/main/examples).
